#include "Button.h"
#include "LED.h"
#include "Configuration.h"

Button* Button::startButton;
Button* Button::targetButton;

int Button::buttonPin[NumButtons] = {GL1, GL2, ABST, LAK};
Button* Button::button[NumButtons];

int pin;

// ----------------------------------------------------------------------------------------------------
//

Button::Button(int pin) : pin{pin} {
  // Welcher?
  button2 = new Button2(pin);
  button2 -> setReleasedHandler(Button::releasedHandler);
}

// ----------------------------------------------------------------------------------------------------
//

void Button::begin() {

  for (int b = 0; b < NumButtons; b++) {
    button[b] = new Button(buttonPin[b]);
  }
  reset();
}

// ----------------------------------------------------------------------------------------------------
//

void Button::reset() {
  startButton = NULL;
  targetButton = NULL;
}

// ----------------------------------------------------------------------------------------------------
//

void Button::loop() {
  for (int b = 0; b < NumButtons; b++) {
    button[b] -> button2 -> loop();
  }
}

// ----------------------------------------------------------------------------------------------------
//

int Button::getPin() {
  return pin;
}

Button* Button::getButton(Button2& btn2) {
  for (int b = 0; b < NumButtons; b++) {
    if (button[b] -> button2 == &btn2) {
      return button[b];
    }
  }
}

// ----------------------------------------------------------------------------------------------------
//

void Button::releasedHandler(Button2& btn2) {

  Button* btn = Button::getButton(btn2);

  // "Durchschieben" der Taster. Selbst wenn aktueller Taster nicht als Ziel
  // gedacht ist und der eigentliche Zieltaster noch folgt, wird dieser dann
  // im nächsten Aufruf zum Ziel- und dieser Taster jetzt zum Starttaster
  startButton = targetButton;
  targetButton = btn;

  LED::animateStartStopButtonStatus(startButton, targetButton);

}
