#include "LED.h"

Adafruit_NeoPixel strip = Adafruit_NeoPixel(NUMPIXELS, LEDStripePin, NEO_GRB + NEO_KHZ800);

// ----------------------------------------------------------------------------------------------------
//

void LED::begin() {
  strip.begin();
}

// ----------------------------------------------------------------------------------------------------
//

void LED::set(int ledIndex, int r, int g, int b, int delayAfter) {
  if (ledIndex < 0 || ledIndex >= NUMPIXELS) return;
  strip.setPixelColor(ledIndex, strip.Color(g, r, b));
  strip.show();
  delay(delayAfter);
}

void LED::setAll(int r, int g, int b, int delayAfter) {
  for (int i = 0; i < NUMPIXELS; i++) {
    set(i, r, g, b, delayAfter);
  }
}

// ----------------------------------------------------------------------------------------------------
//

void LED::unset(int ledIndex, int delayAfter) {
  set(ledIndex, 0, 0, 0, delayAfter);
}

void LED::unsetAll(int delayAfter) {
  for (int i = 0; i < NUMPIXELS; i++) {
    unset(i, delayAfter);
  }
}

// ----------------------------------------------------------------------------------------------------
//

void LED::setBlink(int ledIndex, boolean blink) {
  if (ledIndex >= NumSignalLEDs) return;
  mapping[ledIndex].blink = blink;
}

// ----------------------------------------------------------------------------------------------------
//

void LED::animateStartStopButtonStatus(Button* startButton, Button* targetButton) {

  if (Button::startButton != NULL) LED::set(STATUS_LED1, BLUE, 0);
  else LED::unset(STATUS_LED1, 10);

  if (Button::targetButton != NULL) LED::set(STATUS_LED2, BLUE, 0);
  else LED::unset(STATUS_LED2, 0);
}

// ----------------------------------------------------------------------------------------------------
//
void LED::animateRouteSetting(int i) {
  if (i % 2 == 0) {
    set(STATUS_LED1, BLUE, 10);
    unset(STATUS_LED2, 0);
  } else {
    set(STATUS_LED2, BLUE, 10);
    unset(STATUS_LED1, 0);
  }
}
