#ifndef LED_H
#define LED_H

#include "Button.h"
#include "Configuration.h"

#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h>
#endif

#define LEDStripePin 25 // Pin, an den D_in der ersten LED angeschlossen ist
#define NUMPIXELS 10    // Anzahl der LEDs
#define RED    BR, 0, 0
#define BLUE    0, 0, BR
#define GREEN   0, BR, 0
#define YELLOW BR, BR, 0

class LED {

  public:

    static void begin();

    // Anschalten der betr. LED bzw. aller mit den Farben RGB(r, g, b). Anschließend <delayAfter> warten
    static void set(int ledIndex, int r, int g, int b, int delayAfter);
    static void setAll(int r, int g, int b, int delayAfter);

    // Abschalten der betr. LED. Anschließend <delayAfter> warten
    static void unset(int ledIndex, int delayAfter);
    static void unsetAll(int delayAfter);    

    // Blinken ein-/ausschalten
    static void setBlink(int ledIndex, boolean blink);
    static void setBlinkAll(boolean blink);

    // Darstellung Start-/Zieltastenstatus
    static void animateStartStopButtonStatus(Button* startButton, Button* targetButton);

    // Animation während Fahrstraßenstellen
    static void animateRouteSetting(int i);

};

#endif
